local bump = require "bump/bump"
local player = {
	x = 50,
	y = 50,
	h = 10,
	w = 10,
	speed = 0,
	vy = 0,
	gravity = -500,
	jumpVel = -350,
	isGrounded = false
}

local platform = {
	x = 60,
	y = 400,
	h = 70,
	w = 700

}

local otherPlat = {
	x = 200,
	y = 300,
	h = 30,
	w = 200

}

function love.load()
	world = bump.newWorld()
	Player = player
	Box = platform
	Box2 = otherPlat
	world:add(Player, Player.x, Player.y, Player.w, Player.h)
	world:add(Box, Box.x, Box.y, Box.w, Box.h)
	world:add(Box2, Box2.x, Box2.y, Box2.w, Box2.h)


end

function playerMovement(player, dt)
	if love.keyboard.isScancodeDown("d") then
		player.speed = 50
	elseif love.keyboard.isScancodeDown("a") then
		player.speed = -50
	else
		player.speed = 0
	end
end

function applyGravity(dt)
	local termVel = 500
	
	if player.vy <= termVel then
		player.vy = player.vy - player.gravity*dt
	end

end


function collide(player, dt)
	local futureX = player.x + player.speed * dt
	local futureY = player.y + player.vy * dt
	local actualX, actualY, cols, len = world:check(player, futureX, futureY)

	Player.isGrounded = false

	for i = 1, len do 
		-- col is a table containing information about the objs we are colliding with
		local col = cols[i]
		-- col contains another table that contains info on which side we are colliding with
		if col.normal.y == -1 or col.normal.y == 1 then -- "-1" means top and "1" means bottom 
			Player.vy = 0
		end
		if col.normal.y == -1 then
			Player.isGrounded = true
		end
	end

	player.x = actualX
	player.y = actualY
end


function love.update(dt)
	playerMovement(Player, dt)
	applyGravity(dt)
	collide(Player, dt)

	--player.x = player.x + player.speed*dt

	
end

function love.draw()
	love.graphics.rectangle("line", Player.x, Player.y, Player.w, Player.h)
	love.graphics.rectangle("line", Box.x, Box.y, Box.w, Box.h)
	love.graphics.rectangle("line", Box2.x, Box2.y, Box2.w, Box2.h)
	print(Player.vy)
end

function love.keypressed(key)
	if key == "w" and Player.isGrounded then
		--Player.isGrounded = false
		Player.vy = Player.jumpVel
	end
end